<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
  <button (click)="newRecord(modalDatos)" class="btn btn-primary">
    <i class="fa fa-plus mr-2"></i>Nuevo
  </button>
  <button (click)="printPDF()" class="btn btn-danger ml-1">
    <i class="fa fa-file-pdf mr-2"></i>PDF
  </button>
</app-page-title>

<div class="card mb-3">
  <div class="card-body">

    <ngx-loading [show]="loading" [config]="loadingColor"></ngx-loading>

    <kendo-grid [data]="gridData" [selectable]="true" [reorderable]="true" [resizable]="true"
      [pageable]="{ buttonCount: 5, pageSizes: [10, 25, 50] }" [pageSize]="pageSize"
      (selectionChange)="valueRow($event, modalDatos)" style="height:74vh;">
      <ng-container *ngIf="gridData.length !== 0">
        <kendo-grid-column field="cuarto" title="Cuarto" width="200"></kendo-grid-column>
        <kendo-grid-column field="cfini" title="Fecha Inicio" width="230">
          <ng-template kendoGridCellTemplate let-dataItem>
            {{ dataItem.cfini | date: formatKendo }}
          </ng-template>
        </kendo-grid-column>
        <kendo-grid-column field="cfter" title="Fecha Termino" width="230">
          <ng-template kendoGridCellTemplate let-dataItem>
            {{ dataItem.cfini | date: formatKendo }}
          </ng-template>
        </kendo-grid-column>
        <kendo-grid-column field="crazon" title="Razón" width=""></kendo-grid-column>
        <kendo-grid-command-column width="120">
          <ng-template kendoGridCellTemplate let-dataItem>
            <button class="btn btn-danger" (click)="deleteRecord(dataItem)">
              <i class="fas fa-trash-alt mr-2"></i>Eliminar
            </button>
          </ng-template>
        </kendo-grid-command-column>
      </ng-container>
      <ng-template kendoGridNoRecordsTemplate>
        {{ norecords }}
      </ng-template>
    </kendo-grid>
  </div>
</div>

<ng-template #modalDatos let-c="close" let-d="dismiss">
  <div class="modal-header">
    <div class="modal-title" *ngIf="!update">Nuevo</div>
    <div class="modal-title" *ngIf="update">Actualizar Cuarto: {{ room }}</div>
    <button class="close" aria-label="Close" (click)="d()">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <form #myForm="ngForm" novalidate="" class="d-flex justify-content-center">
      <div class="row-fluid col-12 box-primary animated fadeIn">
        <div class="form-group row mt-2" *ngIf="!update">
          <label class="col-sm-3 col-form-label text-muted">Desde Cuarto</label>
          <div class="col-sm-6">
            <kendo-combobox [data]="rooms" [textField]="'cuarto'" [valueField]="'cuarto'"
              (valueChange)="toRoomValue($event)" class="w-100" name="toRoom" [(ngModel)]="toRoom" [disabled]="update"
              [placeholder]="'Selecciona un cuarto'" required>
            </kendo-combobox>
          </div>
        </div>
        <div class="form-group row" *ngIf="!update">
          <label class="col-sm-3 col-form-label text-muted">Hasta Cuarto</label>
          <div class="col-sm-6">
            <kendo-combobox [data]="rooms" [textField]="'cuarto'" [valueField]="'cuarto'"
              (valueChange)="fromRoomValue($event)" class="w-100" name="fromRoom" [(ngModel)]="fromRoom"
              [disabled]="update || !toRoom" [placeholder]="'Selecciona un cuarto'" required>
            </kendo-combobox>
          </div>
        </div>
        <div class="form-group row">
          <label class="col-sm-3 col-form-label text-muted">Fecha Inicio</label>
          <div class="col-sm-9">
            <kendo-datepicker [format]="formatKendo" [(ngModel)]="toFday" [disabled]="update" name="toFday" required
              (valueChange)="toDateValue($event)">
            </kendo-datepicker>
            <i class="col-sm-3 text-muted h6">{{ dayOfWeek1 }}</i>
          </div>
        </div>
        <div class="form-group row">
          <label class="col-sm-3 col-form-label text-muted">Días</label>
          <div class="col-6 col-sm-3 col-md-3">
            <input type="number" class="form-control" value="1" name="totalDays" [(ngModel)]="totalDays"
              (keyup)="totalOfDays(days.value)" #days>
          </div>
          <div class="col-2 col-md-1">
            <button (click)="plusDays()" class="btn btn-secondary">
              <i class="fa fa-plus"></i>
            </button>
          </div>
          <div class="col-2 col-md-1">
            <button (click)="minusDays()" class="btn btn-secondary">
              <i class="fa fa-minus"></i>
            </button>
          </div>
        </div>
        <div class="form-group row">
          <label class="col-sm-3 col-form-label text-muted">Fecha Término</label>
          <div class="col-sm-9">
            <kendo-datepicker [format]="formatKendo" [(ngModel)]="fromFday" [min]="toFday" name="fromFday" required
              (valueChange)="fromDateValue($event)">
            </kendo-datepicker>
            <i class="col-sm-3 text-muted h6">{{ dayOfWeek2 }}</i>
          </div>
        </div>
        <div class="form-group row">
          <label class="col-sm-3 col-form-label text-muted">Razón</label>
          <div class="col-sm-9">
            <textarea class="form-control" name="crazon" rows="2" [(ngModel)]="crazon" required></textarea>
          </div>
        </div>
      </div>
    </form>
  </div>
  <div class="modal-footer">
    <button class="btn btn-success mr-1" [disabled]="!myForm.valid" (click)="saveRecord(myForm)">
      <i class="fa fa-save mr-2"></i>Guardar
    </button>
    <button (click)="c()" class="btn btn-secondary">
      Cerrar
    </button>
  </div>
</ng-template>